/*==============================================================================

       about box dialog

       Copyright  2001 Pankhurst Algorithmics - All Rights Reserved
       visit www.ebmDevMag.com for permissions/restrictions on use


==============================================================================*/
#include "gui.h"
#include "gui_pkg.h"
//------------------------------------------------------------------------------
class paAbout : public CWindow
{

  private:

    enum
    {
      ID_WINDOW=100,
      ID_BUTTON_CLOSE,
      ID_HELP_CAPTION,
    };

    char m_compileString[99], m_caption[99];
    const char *m_programName;

	  S32 MsgHandler(MSG_TYPE type, CViewable *from, S32 data);
    void Draw();

  public:

    paAbout(const char *text,const char *programName,int versionMajor,int versionMinor);

};
//------------------------------------------------------------------------------
paAbout::paAbout(const char *text,const char *programName,int versionMajor,int versionMinor)
	: CWindow(ID_WINDOW,0,0,200,240,"",false,false,false),
    m_programName(programName)
{
  sprintf(m_caption,"About %s & Help",programName);
  SetTitle(m_caption);
  CTextEdit *helpInfo=new CTextEdit(ID_HELP_CAPTION,190,165,TEXTOPTION_NOEDIT|TEXTOPTION_NOUNDERLINE);
  AddChild(helpInfo,3,2); // help text
  AddChild(new CButton(ID_BUTTON_CLOSE,45,20,"Close"),148,185);
  helpInfo->SetText(text);
  sprintf(m_compileString,"Version %d.%d",versionMajor,versionMinor);
	SetFocus(helpInfo);
}
//------------------------------------------------------------------------------
S32 paAbout::MsgHandler( MSG_TYPE type, CViewable *from, S32 data )
{
  if ( MSG_BUTTON_SELECT==type && ID_BUTTON_CLOSE==from->GetID() )
  {
    Close();
    return 1;
  }
  return CWindow::MsgHandler(type, from, data);
}
//------------------------------------------------------------------------------
void paAbout::Draw(void)
{
	CWindow::Draw();
  RECT rect;
  GetUsableRect(&rect);
  // do drawing
  DrawRectFilled(0,170,rect.width,3,COLOR_BLACK);
  DrawText(m_compileString,8,177,0,COLOR_BLACK,COLOR_WHITE,-1,IMG_CMB_SRC);
  // draw compile info as well
  DrawText("Compiled " __DATE__ ,8,189,0,COLOR_BLACK,COLOR_WHITE,-1,IMG_CMB_SRC);
  const FONT *font=GUI_GetFont(16,CTRL_BOLD);
  if (NULL==font) // bold not available?
    font=GUI_GetFont(16,CTRL_NORMAL);
  if (NULL==font) // bad size?
    font=GUI_GetFont(12,CTRL_NORMAL);
  // draw program title big, and at bottom
  DrawText(m_programName,5,203,font,COLOR_BLACK,COLOR_WHITE,-1,IMG_CMB_SRC);
	DrawChildren();
}
/*==============================================================================

       about window calling routine

==============================================================================*/
void AboutWindow(const char *message,const char *programName,int versionMajor,int versionMinor)
{
  GUI_EventLoop(new paAbout(message,programName,versionMajor,versionMinor));
}
//------------------------------------------------------------------------------
